/*
 * ConfigDialog.java
 *
 * Created on 2008/05/24, 6:33
 */

package p4uclient;

/**
 * 設定ダイアログ
 * @author tondol
 */
public class OptionBox extends javax.swing.JDialog {
    static private OptionBox instance = null;
    
    /** Creates new form ConfigDialog */
    private OptionBox(java.awt.Frame parent) {
        super(parent, true);
        initComponents();
    }
    
    /**
     * 設定ダイアログを表示
     */
    static public void showOptionBox() {
        if (instance == null) {
            instance = new OptionBox(MainApp.window);
        }
        instance.resetComponents();
        instance.setVisible(true);
    }
    
    /**
     * 設定ダイアログの内容を反映
     */
    private void saveOptionBox() {
        MainApp.option.host    = txtHost.getText();
        MainApp.option.port    = Integer.parseInt(txtPort.getText());
        MainApp.option.listen  = Integer.parseInt(txtListen.getText());
        MainApp.option.updir   = txtUpDir.getText();
        MainApp.option.downdir = txtDownDir.getText();
        MainApp.option.myhost  = txtMyHost.getText();
    }
    
    /**
     * 各コンポーネントをリセット
     */
    private void resetComponents() {
        txtHost.setText(MainApp.option.host);
        txtPort.setText(String.valueOf(MainApp.option.port));
        txtListen.setText(String.valueOf(MainApp.option.listen));
        txtUpDir.setText(MainApp.option.updir);
        txtDownDir.setText(MainApp.option.downdir);
        txtMyHost.setText(MainApp.option.myhost);
        btnApply.requestFocus();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        txtHost = new javax.swing.JTextField();
        txtPort = new javax.swing.JTextField();
        txtListen = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        txtUpDir = new javax.swing.JTextField();
        btCancel = new javax.swing.JButton();
        btnApply = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        txtDownDir = new javax.swing.JTextField();
        txtMyHost = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("P4UClient - 設定");
        setResizable(false);

        jLabel1.setText("接続ホスト");

        jLabel2.setText("接続ポート");

        jLabel3.setText("待受ポート");

        txtHost.setFont(txtHost.getFont().deriveFont(txtHost.getFont().getSize()+2f));
        txtHost.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });

        txtPort.setFont(txtPort.getFont().deriveFont(txtPort.getFont().getSize()+2f));
        txtPort.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });

        txtListen.setFont(txtListen.getFont().deriveFont(txtListen.getFont().getSize()+2f));
        txtListen.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });

        jLabel4.setText("送信フォルダ");

        txtUpDir.setFont(txtUpDir.getFont().deriveFont(txtUpDir.getFont().getSize()+2f));
        txtUpDir.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });

        btCancel.setText("キャンセル");
        btCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonActions(evt);
            }
        });

        btnApply.setText("適用");
        btnApply.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonActions(evt);
            }
        });

        jLabel5.setText("受信フォルダ");

        txtDownDir.setFont(txtDownDir.getFont().deriveFont(txtDownDir.getFont().getSize()+2f));
        txtDownDir.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });

        txtMyHost.setFont(txtMyHost.getFont().deriveFont(txtMyHost.getFont().getSize()+2f));

        jLabel6.setText("DDNS名");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel5)
                            .addComponent(jLabel4)
                            .addComponent(jLabel3)
                            .addComponent(jLabel2)
                            .addComponent(jLabel1)
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtDownDir, javax.swing.GroupLayout.DEFAULT_SIZE, 282, Short.MAX_VALUE)
                            .addComponent(txtUpDir, javax.swing.GroupLayout.DEFAULT_SIZE, 282, Short.MAX_VALUE)
                            .addComponent(txtListen, javax.swing.GroupLayout.DEFAULT_SIZE, 282, Short.MAX_VALUE)
                            .addComponent(txtPort, javax.swing.GroupLayout.DEFAULT_SIZE, 282, Short.MAX_VALUE)
                            .addComponent(txtHost, javax.swing.GroupLayout.DEFAULT_SIZE, 282, Short.MAX_VALUE)
                            .addComponent(txtMyHost, javax.swing.GroupLayout.DEFAULT_SIZE, 282, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(btnApply)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btCancel)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtHost, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtPort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtListen, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtUpDir, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(txtDownDir, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtMyHost, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnApply)
                    .addComponent(btCancel))
                .addContainerGap())
        );

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        java.awt.Dimension dialogSize = getSize();
        setLocation((screenSize.width-dialogSize.width)/2,(screenSize.height-dialogSize.height)/2);
    }// </editor-fold>//GEN-END:initComponents

    private void buttonActions(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonActions
        String action = evt.getActionCommand();
        if (action.equals("適用")) {
            saveOptionBox();
            setVisible(false);
        } else if (action.equals("キャンセル")) {
            setVisible(false);
        }
}//GEN-LAST:event_buttonActions

    private void selectTextAction(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_selectTextAction
        javax.swing.JTextField textBox = (javax.swing.JTextField)evt.getSource();
        textBox.selectAll();
    }//GEN-LAST:event_selectTextAction

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btCancel;
    private javax.swing.JButton btnApply;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JTextField txtDownDir;
    private javax.swing.JTextField txtHost;
    private javax.swing.JTextField txtListen;
    private javax.swing.JTextField txtMyHost;
    private javax.swing.JTextField txtPort;
    private javax.swing.JTextField txtUpDir;
    // End of variables declaration//GEN-END:variables
    
}
